<?php
/*-----------引入檔案區--------------*/
use Xmf\Request;
use XoopsModules\Kw_leave\Kw_leave;
use XoopsModules\Tadtools\Utility;
use XoopsModules\Tadtools\SweetAlert;
use XoopsModules\Tadtools\FormValidator;
use XoopsModules\Tadtools\CkEditor;
use XoopsModules\Tadtools\My97DatePicker;
use XoopsModules\Tadtools\EasyResponsiveTabs;

require_once __DIR__ . '/header.php'; //kw_leave/header.php
$xoopsOption['template_main'] = "kw_leave_config.tpl";

if (!$iskwLeaveAdmin) {
    redirect_header('index.php', 3, _MD_KWLEAVE_FORBBIDEN); //沒有存取權限
    exit;
}

/*-----------執行動作判斷區----------*/
require_once $GLOBALS['xoops']->path('/modules/system/include/functions.php');

$op     = Request::getString('op');
$type   = Request::getString('type', $default = 'office');
$id     = Request::getInt('config_id');
$tab    = Request::getInt('tab');

if(empty($tab)) $tab = array_search($type, $allDB)+1;

//刪除全部學生和班級時間限制7-8月
if(Date('m')== 7 || Date('m')== 8){
    $isDelAll= true;
    $xoopsTpl->assign('isDelAll', true);
    $xoopsTpl->assign('isUpgrade', true);
}else{
    $isDelAll= false;
    $xoopsTpl->assign('isDelAll', false);
}

switch ($op) {
    //刪除全部班級或學生或所有假單
    case 'kw_leave_all_delete': //ajax
        $isDel = Request::getInt('isDel');
        $year = Date('Y')- 1914; //3年前
        if($isDel && $isDelAll && $iskwLeaveAdmin){ //檢查全部刪除允許時間
            if($type == 'book')
                $sql = 'delete from `' . $xoopsDB->prefix('kw_leave_book') . "` where `book_year`< {$year}";    
            else
                $sql = 'delete from `' . $xoopsDB->prefix('kw_leave_'.$type) . "` where 1=1";    
            $xoopsDB->queryF($sql) or Utility::web_error($sql);
            die('{"result":1,"msg":"刪除成功!"}');
        }
        else{
            die('{"result":0,"msg":"錯誤，無權限或非刪除期間!"}');
        }
        exit;

    //升級學生
    case 'kw_leave_stu_upgrade': //ajax
        $uid = Request::getInt('user');
        if($xoopsUser->isAdmin($uid) && $isDelAll ) {
            die(kw_leave_stu_upgrade());
        }else{
            die('{"result":0,"msg":"錯誤，無權限或非升級期間!"}');
        }
        exit;

    //顯示班級學生
    case 'kw_leave_stu_show': //ajax 
        $class_id  = Request::getInt('class_id');
        $stu_arr = Kw_leave:: kw_leave_get_data('stu','','class_id',$class_id);
        $data='';
        foreach($stu_arr as $stu){
            $data = $data."<div class='col-md-4 ms-auto border border-primary'>{$stu['stu_num']}{$stu['stu_title']}({$stu['stu_id']})</div>";
        }
        die($data);
        exit;

    //新增或刪除特殊日期
    case 'kw_leave_config_date_add'://ajax
        $date     = Request::getString('date');
        die(kw_leave_config_date($type, $date, 'add'));
        exit;
    case 'kw_leave_config_date_del'://ajax
        $date     = Request::getString('date');
        die(kw_leave_config_date($type, $date, 'del'));
        exit;

    //上傳班級或學生
    case 'kw_leave_config_upload': //ajax
        list($isDone, $msg) = Kw_leave::kw_leave_upload($type);
        $status = $isDone ? 1:0;
        die('{"status":'.$status.',"size":"'.$_FILES['file']['size'].'","content":"'.$msg.'"}');
        

    //config 通用於offie cate process class stu
    case 'kw_leave_config_insert':
        $config_id = kw_leave_config_insert($type);
        header("location: {$_SERVER['PHP_SELF']}#setupTab".$tab);
        exit;

    case 'kw_leave_config_update':
        kw_leave_config_update($type, $id);
        header("location: {$_SERVER['PHP_SELF']}#setupTab".$tab);
        exit;

    case 'kw_leave_config_delete': 
        kw_leave_config_delete($type, $id);
        header("location: {$_SERVER['PHP_SELF']}#setupTab".$tab);
        exit;
        
    case 'kw_leave_config_isenable': //啟用或停用
        $isenable = Request::getInt('isenable');
        Kw_leave::kw_leave_update_isEnable($type, $id, $isenable);
        header("location: {$_SERVER['PHP_SELF']}#setupTab".$tab);
        break;

    //設定老師
    case 'kw_leave_save_master': 
        $masters_uid = Request::getString('masters_uid');
        kw_leave_saveMaster($masters_uid);
        header("location: {$_SERVER['PHP_SELF']}#setupTab{$tab}");
        exit;
        
    default:
        // die("login".$xoopsModuleConfig['stu_login']);
        $op = 'kw_leave_config';    
        kw_leave_config_list($type,$xoopsModuleConfig['stu_login']);
        kw_leave_config_form($type, $id);
        break;
}

/*-----------秀出結果區--------------*/
$xoopsTpl->assign('op', $op);
$xoopsTpl->assign("toolbar", Utility::toolbar_bootstrap($interface_menu,false,$interface_icon));
$xoopsTpl->assign('uid', $kw_leave_uid);
$xoopsTpl->assign('error',$kw_leave_error);
$xoopsTpl->assign('iskwLeaveAdmin', $iskwLeaveAdmin);
$xoopsTpl->assign('iskwLeaveCheck', $iskwLeaveCheck);
$xoTheme->addStylesheet(XOOPS_URL . '/modules/kw_leave/assets/css/module.css');
$xoTheme->addStylesheet(XOOPS_URL . '/modules/tadtools/css/vtable.css');
require_once XOOPS_ROOT_PATH . '/footer.php';



/*-----------function區--------------*/
function kw_leave_config_list($type,$stu_login)
{
    global $xoopsTpl, $allDB, $school_grade,$school_class,$uid_arr;

    //取得所有index=>uid,uname,name 送到前端
    list($user_arr, $uid_arr, $noMaster_arr, $master_arr) = Kw_leave::kw_leave_get_users(); 
    $xoopsTpl->assign('user_arr', $user_arr);   //user_arr[0]['uid'] = uid 
    $xoopsTpl->assign('uid_arr', $uid_arr);     //uid_arr[uid] = nume
    $xoopsTpl->assign('noMaster_arr', $noMaster_arr);
    $xoopsTpl->assign('master_arr', $master_arr);     //master_arr[] = uid
    $xoopsTpl->assign('stu_login', $stu_login); //學生登入方式
    
    //取得所有office送到前端
    $office_arr = Kw_leave:: kw_leave_get_allTitle('office');
    $xoopsTpl->assign('office_arr', $office_arr); //office_arr[id]=title
    
    //取得班級設定送到前端
    $xoopsTpl->assign('school_grade',$school_grade);
    $xoopsTpl->assign('school_class',$school_class);
    
    
    //取得已建立班級送到前端
    $class_arr = Kw_leave::kw_leave_get_data('class');
    $xoopsTpl->assign('class_arr',$class_arr);

    //取得學生相關資訊
    $stu_check = Kw_leave::kw_leave_get_stuCheck(); //檢查班級是否有學生資料
    $xoopsTpl->assign('stu_check',$stu_check);
    // var_dump($stu_check);
    if($class_id  = Request::getInt('class_id')){
        $stu_arr = Kw_leave:: kw_leave_get_data('stu','','class_id',$class_id);
        $xoopsTpl->assign('stu_arr',$stu_arr);
        $xoopsTpl->assign('class_id',$class_id);
    }
    
    //頁簽的js    
    $responsive_tabs = new EasyResponsiveTabs('#setupTab');
    $responsive_tabs->rander();
    
    //刪除確認的JS
    $sweet_alert_obj = new SweetAlert();
    foreach ($allDB as $key => $type) {
        if($key < 3 ){
            //sweetAlert render
            $sweet_alert_obj->render("delete_{$type}_func", "{$_SERVER['PHP_SELF']}?type={$type}&op=kw_leave_config_delete&config_id=", "{$type}_id");
            //get allData
            $all_content[$type] = Kw_leave::kw_leave_get_data($type);
        }
    }
    $xoopsTpl->assign("all_config_content", $all_content);
}



/**
 * @param        $type 
 * @param string $type_id
 */
function kw_leave_config_form($type, $type_id)
{
    global $xoopsTpl,$allDB,$workDate_path,$restDate_path;

    foreach ($allDB as $key => $type) {
        if($key < 5 && $type !='master'){
            //取得更新欄位值
            $DBV = empty($type_id) ? [] : Kw_leave::kw_leave_get_data($type, $type_id);
            
            if($type === 'process'){
                $office_id = !isset($DBV['office_id']) ? '' : $DBV['office_id'];
                $xoopsTpl->assign('office_id', $office_id);
                $process_uid = !isset($DBV[$type.'_uid']) ? '' : $DBV[$type.'_uid'];
                $xoopsTpl->assign($type.'_uid', $process_uid);
                $process_backup_uid = !isset($DBV[$type.'_backup_uid']) ? '' : $DBV[$type.'_backup_uid'];
                $xoopsTpl->assign($type.'_backup_uid', $process_backup_uid);
            }
            if($type === 'class'){    
                $class_teacher_uid = !isset($DBV[$type . '_teacher_uid']) ? '' : $DBV[$type . '_teacher_uid'];
                $xoopsTpl->assign($type . '_teacher_uid', $class_teacher_uid);
            }
             //特殊工作日和假日設定
            if($type === 'cate'){
                $workDate_arr = file_exists($workDate_path)?
                json_decode(file_get_contents($workDate_path), true): file_put_contents($workDate_path, '');
                $restDate_arr = file_exists($restDate_path)? 
                json_decode(file_get_contents($restDate_path), true): file_put_contents($restDate_path, '["01-01","02-28"]');
                $xoopsTpl->assign('workDate_arr', $workDate_arr);
                $xoopsTpl->assign('restDate_arr', $restDate_arr);
            }
            //設定 config_id 欄位的預設值
            $id = !isset($DBV[$type . '_id']) ? $type_id : $DBV[$type . '_id'];
            $xoopsTpl->assign($type . '_id', $id);
            //設定 title 欄位的預設值
            $title = !isset($DBV[$type . '_title']) ? '' : $DBV[$type . '_title'];
            $xoopsTpl->assign($type . '_title', $title);
            //設定 sort 欄位的預設值
            $sort = !isset($DBV[$type . '_sort']) ? kw_leave_max_sort($type) : $DBV[$type . '_sort'];
            $xoopsTpl->assign($type . '_sort', $sort);
            //設定 enable 欄位的預設值
            $isenable = !isset($DBV[$type . '_isenable']) ? '' : $DBV[$type . '_isenable'];
            $xoopsTpl->assign($type.'_isenable', $isenable);
            
            $op = empty($type_id) ? "kw_leave_config_insert" : "kw_leave_config_update";
            $xoopsTpl->assign('_op', $op);
            $xoopsTpl->assign('type', $type);
            $xoopsTpl->assign('config_id', $type_id);

            //加入Token安全機制
            require_once XOOPS_ROOT_PATH . '/class/xoopsformloader.php';
            $token      = new \XoopsFormHiddenToken();
            $token_form = $token->render();
            $xoopsTpl->assign($type . '_token', $token_form);
        }
        
    }//end foreach
    
    
    //套用formValidator驗證機制
    $formValidator = new FormValidator('.myForm', true);
    $formValidator->render();
    
    //引入日期
    $cal = new My97DatePicker();
    $cal::render();
    

}


function kw_leave_config_insert($type)
{
    global $xoopsDB,$xoopsTpl,$tab,$school_grade,$school_class;
    
    //XOOPS表單安全檢查
    if (!$GLOBALS['xoopsSecurity']->check() || empty($type)) {
        $error = implode('<br>', $GLOBALS['xoopsSecurity']->getErrors());
        $xoopsTpl->assign('error',$error);
        // die($type.$error);
        redirect_header($_SERVER['PHP_SELF']."#setupTab".$tab, 3, $error); 
    }
    
    // $myts = \MyTextSanitizer::getInstance();
    //$myts->displayTarea($text, $html=1, $smiley=0, $xcode=0, $image=0, $br=0);
    //$myts->htmlSpecialChars($text);
    //$myts->addSlashes(文字);

    $myts = \MyTextSanitizer::getInstance();
    $type_title= Request::getString("{$type}_title");
    $title  = $myts->addSlashes($type_title); 
    $sort       =Request::getInt("{$type}_sort");
    $isenable   =Request::getInt("{$type}_isenable");
    // $sort   = (int) $_POST[$type . '_sort'];
    // $isenable = (int) $_POST[$type . '_isenable'];
    
    if ($type === 'process') {
        $office_id  = Request::getInt('office_id');
        $uid        = Request::getInt($type.'_uid');
        $backup_uid = Request::getInt($type.'backup_uid');

        //檢查uid是否重複
        if(!isset($uid) || !isset($backup_uid) )
            redirect_header($_SERVER['PHP_SELF']."#setupTab".$tab, 3, _MD_KWLEAVE_UID_NEED);
        else if(Kw_leave::kw_leave_check_uid($type, $uid) ) 
            redirect_header($_SERVER['PHP_SELF']."#setupTab".$tab, 3, _MD_KWLEAVE_UID_WRONG);
        else if($uid==$backup_uid)
            redirect_header($_SERVER['PHP_SELF']."#setupTab".$tab, 3, _MD_KWLEAVE_UID_REPEATE);

        $sql = 'insert into `' . $xoopsDB->prefix('kw_leave_' . $type) . "` (
            `office_id`,
            `{$type}_title`,
            `{$type}_uid`,
            `{$type}_backup_uid`,
            `{$type}_sort`,
            `{$type}_isenable`
            ) values(
            '{$office_id}',
            '{$title}',
            '{$uid}',
            '{$backup_uid}',
            '{$sort}',
            '{$isenable}'
            )";
        // echo $sql;
        $xoopsDB->query($sql) or Utility::web_error($sql);
    } else if($type == 'class'){
        $class_id = (int)$title;
        if($class_id > 100){//101-901
            list($grade,$class) = explode("0",$title);
            $title = $school_grade[$grade]."年". $school_class[$class];
        }else{ //幼兒園
            $grade=0;
            $class=$class_id;
            $title = '幼'. $school_class[$class];
        }

        $teacher_uid = Request::getInt("class_teacher_uid");
        $master_arr = Kw_leave::kw_leave_get_masters(); 
        $teacher = $master_arr[$teacher_uid]['name'];
        $class_teacher = $teacher; //"{\"class_teacher\":\"{$teacher}\"}";
        
        $total= Request::getInt("class_total"); //班級人數
        $sql = 'insert into `' . $xoopsDB->prefix('kw_leave_' . $type) . "` (
            `{$type}_id`,
            `{$type}_title`,
            `{$type}_grade`,
            `{$type}_class`,
            `{$type}_num`,
            `{$type}_teacher`,
            `{$type}_sort`,
            `{$type}_isenable`,
            `{$type}_teacher_uid`
            ) values(
            '{$class_id}',
            '{$title}',
            '{$grade}',
            '{$class}',
            '{$total}',
            '{$class_teacher}',
            '{$sort}',
            '{$isenable}',
            '{$teacher_uid}'
            )";
        $xoopsDB->query($sql) or Utility::web_error($sql);
    }else {
        $sql = 'insert into `' . $xoopsDB->prefix('kw_leave_' . $type) . "` (
            `{$type}_title`,
            `{$type}_sort`,
            `{$type}_isenable`
            ) values(
            '{$title}',
            '{$sort}',
            '{$isenable}'
        )";
        $xoopsDB->query($sql) or Utility::web_error($sql);
    }
    //取得最後新增資料的流水編號
    $id = $xoopsDB->getInsertId();
    
    return $id;
}


function kw_leave_config_update($type, $type_id)
{
    global $xoopsDB,$tab;
    
    if (empty($type_id) or empty($type)) {
        // die($type.$type_id._MD_KWLEAVE_NEED_CATE_ID);
        redirect_header($_SERVER['PHP_SELF']."#setupTab".$tab, 3, _MD_KWLEAVE_NEED_FIELD); //沒有指定編號
    }
    //XOOPS表單安全檢查
    if (!$GLOBALS['xoopsSecurity']->check()) {
        $error = implode('<br>', $GLOBALS['xoopsSecurity']->getErrors());
        // die($type.$type_id.$error);
        redirect_header($_SERVER['PHP_SELF']."#setupTab".$tab, 3, $error);
        // return "安全表單錯誤!".$error;
    }

    $myts       =  \MyTextSanitizer::getInstance();
    $title      =  $myts->addSlashes(Request::getString("{$type}_title"));
    $sort       =  Request::getInt("{$type}_sort");
    $isenable   =  Request::getInt("{$type}_isenable");
    // echo $type_id;
    if ($type == 'process') {
        $office_id = Request::getInt("office_id");
        $uid       = Request::getInt("{$type}_uid");
        $backup_uid= Request::getInt("{$type}_backup_uid");

        if (empty($office_id) or empty($uid) or empty($backup_uid)) {
            redirect_header($_SERVER['PHP_SELF']."#setupTab".$tab, 3, _MD_KWLEAVE_NEED_FIELD); //沒有指定編號
        }

        $sql = 'update `' . $xoopsDB->prefix('kw_leave_' . $type) . "` set
        `office_id` =   '{$office_id}',
        `{$type}_title` = '{$title}',
        `{$type}_uid` = '{$uid}',
        `{$type}_backup_uid` = '{$backup_uid}',
        `{$type}_sort` = '{$sort}',
        `{$type}_isenable` = '{$isenable}'
        where `{$type}_id` = '{$type_id}'";
        $xoopsDB->queryF($sql) or Utility::web_error($sql);

    }else if($type == 'class') {
        
        $teacher_uid = Request::getInt("class_teacher_uid");
        $class_total = Request::getInt("class_total");
        if (empty($teacher_uid) or empty($class_total)) {
            redirect_header($_SERVER['PHP_SELF']."#setupTab".$tab, 3, _MD_KWLEAVE_NEED_FIELD); //沒有指定編號
        }
        $teacher_uid = Request::getInt("class_teacher_uid");
        $master_arr = Kw_leave::kw_leave_get_masters(); 
        $teacher = $master_arr[$teacher_uid]['name'];
        $class_teacher = $teacher ;//"{\"class_teacher\" : \"{$teacher}\"}";
        
        $sql = 'update `' . $xoopsDB->prefix('kw_leave_' . $type) . "` set
        `{$type}_num` = '{$class_total}',
        `{$type}_teacher` = '{$class_teacher}' ,
        `{$type}_sort` = '{$sort}',
        `{$type}_isenable` = '{$isenable}',
        `{$type}_teacher_uid` = '{$teacher_uid}'
        where `{$type}_id` = '{$type_id}'";
        $xoopsDB->queryF($sql) or Utility::web_error($sql);
        // echo $sql;
    }else{
        $sql = 'update `' . $xoopsDB->prefix('kw_leave_' . $type) . "` set
        `{$type}_title` = '{$title}',
        `{$type}_sort` = '{$sort}',
        `{$type}_isenable` = '{$isenable}' 
        where `{$type}_id` = '{$type_id}'";
        $xoopsDB->queryF($sql) or Utility::web_error($sql);
    }
    return $type_id;
}

function kw_leave_config_delete($type, $type_id)
{
    global $xoopsDB,$tab;
    if (!isset($type_id) or empty($type)) {
        // die($type.$type_id);
        redirect_header($_SERVER['PHP_SELF']."#setupTab".$tab, 3, _MD_KWLEAVE_NEED_FIELD); //沒有指定編號

    }else {
        $sql = 'DELETE FROM `' . $xoopsDB->prefix('kw_leave_' . $type) . "` where `{$type}_id` = '{$type_id}' ";
        $xoopsDB->queryF($sql) or Utility::web_error($sql);
        //return true;
    }
}



//重設教師群組
function kw_leave_saveMaster($masters_uid)
{
    global $tab;
    if (!isset($masters_uid) ) {
        redirect_header($_SERVER['PHP_SELF']."#setupTab".$tab, 3, _MD_KWLEAVE_NEED_FIELD); //沒有指定編號
    }
    // //XOOPS表單安全檢查
    // if (!$GLOBALS['xoopsSecurity']->check()) {
    //     $error = implode('<br>', $GLOBALS['xoopsSecurity']->getErrors());
    //     // die($type.$type_id.$error);
    //     redirect_header($_SERVER['PHP_SELF']."#setupTab".$tab, 3, $error);
    //     // return "安全表單錯誤!".$error;
    // }

    $masters = explode(',', $masters_uid);
    $groupid = Kw_leave::kw_leave_groupID(_MD_KWLEAVE_MASTER_GROUP);
    //列出群組中有哪些人
    if ($groupid) {
        $memberHandler = xoops_getHandler('member');
        $master_arr      = $memberHandler->getUsersByGroup($groupid);
        //先從群組移除
        $memberHandler->removeUsersFromGroup($groupid, $master_arr);
        //再加入群組
        if (is_array($masters)) {
            $memberHandler = xoops_getHandler('member');
            foreach ($masters as $uid) {
                $memberHandler->addUserToGroup($groupid, $uid);
            }
        }
    }

}

//add rest & work Date
function kw_leave_config_date($type, $date, $mode){
    global $workDate_path,$restDate_path;

    if(!isset($type) || !isset($date)) 
        return "沒有日期資料!";

    if($type=='rest'){
        $json_arr = json_decode(file_get_contents($restDate_path), true);
        if($json_arr){
            if($mode == 'add')
                array_push($json_arr, $date);
            if($mode == 'del' )
            {
                $i = array_search($date, $json_arr);
                if ($i!== false) unset($json_arr[$i]);
            }
        }
        else
            $json_arr=array($date);

        $json_string = json_encode( $json_arr);
        file_put_contents($restDate_path, $json_string);
        if($mode == 'add')
            return "新增假日成功!";
        if($mode == 'del')
            return "刪除假日成功!";
    }
    else if($type=="work"){
        $json_arr = json_decode(file_get_contents($workDate_path), true);
        if($json_arr){
            if($mode == 'add')
                array_push($json_arr, $date);
            if($mode == 'del' )
            {
                $i = array_search($date, $json_arr);
                if ($i!== false) unset($json_arr[$i]);
            }
        }
        else
            $json_arr=array($date);
        $json_string = json_encode( $json_arr);
        file_put_contents($workDate_path, $json_string);

        if($mode == 'add')
            return "新增特殊工作日成功!";
        if($mode == 'del')
            return "刪除特殊工作日成功!";
    }
    else{
        return "類型錯誤!";
    }
}


//學生年級升級
function kw_leave_stu_upgrade(){
    global $xoopsDB,$school_grade;
    $last_grade = array_key_last($school_grade); //學校的最後一個年級
    $this_year = date('Y')-1911; //今年
    $this_month = date('m');
    if($this_month<7 || $this_month>9)
        return '{"result":0,"msg":"錯誤，不符合升級時間!"}';
    //檢查是否符合升級條件：112年-6年級 = 106(入學年)
    $sql = 'select count(`stu_year`) from `' . $xoopsDB->prefix('kw_leave_stu') . "` where stu_year ={$this_year} -`stu_grade`";
    $result = $xoopsDB->query($sql) or Utility::web_error($sql);
    list($num) = $xoopsDB->fetchRow($result);

    if($num == 0){//判斷合理升級
        return '{"result":0,"msg":"錯誤，不符合升級條件!"}';
    }
    //刪除最高年級
    $sql = 'delete from `' . $xoopsDB->prefix('kw_leave_stu') . "`  where `stu_grade` ={$last_grade} ";
    $xoopsDB->query($sql);

    //全校升級
    $sql = 'update `' . $xoopsDB->prefix('kw_leave_stu') . "` set `stu_total`= 0,
    `stu_grade` = `stu_grade`+1, `class_id` =`class_id`+100  where `class_id` > 100 ";
    return $xoopsDB->queryF($sql) ?  '{"result":1,"msg":"全校學生升級成功!"}' : Utility::web_error($sql);
    
}