<?php
/*-----------引入檔案區--------------*/
use Xmf\Request;
use XoopsModules\Kw_leave\Kw_leave;
use XoopsModules\Tadtools\Utility;
use XoopsModules\Tadtools\SweetAlert;
use XoopsModules\Tadtools\FormValidator;
use XoopsModules\Tadtools\CkEditor;
use XoopsModules\Tadtools\My97DatePicker;

require_once  __DIR__ . '/header.php';
$xoopsOption['template_main'] = "kw_leave_index.tpl";
$school_time = $xoopsModuleConfig['school_time'];
require_once  $GLOBALS['xoops']->path('/modules/system/include/functions.php');
/*--
學生請假表單
學生請假列表(學期)
---*/

/*-----------執行動作判斷區----------*/

$op = Request::getString('op');
$book_id = Request::getInt('book_id');
$today = date('Y-m-d');

switch ($op) {

    case 'kw_leave_login_apply':
        kw_leave_login_apply();
        header("location: {$_SERVER['PHP_SELF']}");
        exit;
    case 'kw_leave_logout':
        $_SESSION['stu_id'] = '';
        $_SESSION['stuID'] = '';
        header("location: {$_SERVER['PHP_SELF']}");
        exit;
    //book
    case 'kw_leave_book_insert':
        $book_id = kw_leave_book_insert();
        header("location: book.php");
        exit;
    case 'kw_leave_book_update':
        kw_leave_book_update($book_id);
        header("location: book.php");
        exit;

    default:
        if($xoopsModuleConfig['stu_login']==1){ //openID
            if(empty($xoopsModuleConfig['school_code'])){
                $error = "學校代碼錯誤!請洽資訊組長修正!";
                $xoopsTpl->assign('error', $error);

            }else if(isset($kw_leave_uid)){
                
                if(!kw_leave_check_openID($kw_leave_uid,$xoopsModuleConfig['school_code'])){
                    $error = "登入資料錯誤!非本校學生!!";
                    $xoopsTpl->assign('error', $error);
                }else {//pass
                    kw_leave_book_form($_SESSION['stu_id'], $book_id);
                    $op = 'kw_leave_book_form';
                }
            }else{
                kw_leave_login_form($xoopsModuleConfig['stu_login']);
                $op = 'kw_leave_login_form'; 
            }
            
        }else{ //login form
            if (!empty($_SESSION['stuID']) and !empty($_SESSION['stu_id'])){
                kw_leave_book_form($_SESSION['stu_id'], $book_id);
                $op = 'kw_leave_book_form';
            }else{
                kw_leave_login_form($xoopsModuleConfig['stu_login']);
                $op = 'kw_leave_login_form'; 
            }
        }
        break;
        
}

/*-----------秀出結果區--------------*/
$xoopsTpl->assign('op', $op);
$xoopsTpl->assign("toolbar", Utility::toolbar_bootstrap($interface_menu,false,$interface_icon));
$xoopsTpl->assign('today', $today);
$xoopsTpl->assign('uid', $kw_leave_uid);
$xoopsTpl->assign('iskwLeaveAdmin', $iskwLeaveAdmin);
$xoopsTpl->assign('iskwLeaveCheck', $iskwLeaveCheck);
$xoTheme->addStylesheet(XOOPS_URL . '/modules/kw_leave/assets/css/module.css');
$xoTheme->addStylesheet(XOOPS_URL . '/modules/tadtools/css/vtable.css');
require_once XOOPS_ROOT_PATH . '/footer.php';



/*-----------function區--------------*/

function kw_leave_check_openID($uid, $school_code){
    global $xoopsDB;
    if (empty($uid) || empty($school_code)) {
        return false;
    }
    $sql = 'select `uname`,`name`, `user_from`,`user_sig` from `' . $xoopsDB->prefix('users') . "`  where `uid` = '{$uid}' and `user_icq`='student' and `user_intrest`='{$school_code}' ";
    $result = $xoopsDB->query($sql);
    list($uname,$name,$grade,$class) = $xoopsDB->fetchRow($result);
    if($uname && $name && $grade && $class){
        $user_arr = explode('_',$uname); //stxxxxxxx_tn
        $user = $user_arr[0];//stxxxxxxx
        $sql = 'select `stu_sn` from `' . $xoopsDB->prefix('kw_leave_stu') . "`  where `stu_id`='{$user}' and `stu_grade`={$grade} and `stu_class`='{$class}' ";
        // die($sql);
        $result = $xoopsDB->query($sql);
        list($stu_sn) = $xoopsDB->fetchRow($result);
        if(empty($stu_sn)){ //first
            $semester = kw_leave_getSemester();
            //class_id
            if(!$class_id = kw_leave_getClassID($grade,$class)) return false;
            
            $sql = 'INSERT INTO `'.$xoopsDB->prefix('kw_leave_stu')."` (`stu_id`, `class_id`, `stu_title`,`stu_num`,`stu_uid`,`stu_year`,`stu_grade`,`stu_class`,`stu_total`)  VALUE ( '{$user}','{$class_id}','{$name}','','{$uid}','{$semester['this_year']}','{$grade}','{$class}','0')";
            $xoopsDB->queryF($sql) ;
        }
        $_SESSION['stu_id'] =$user; //openID
        $_SESSION['stuID'] = $uid; //uid
        return true;
    }
    else
        return  false;
    
}

function kw_leave_login_form($stu_login){
    global $xoopsTpl,$school_grade,$school_class;

    //加入Token安全機制
    require_once XOOPS_ROOT_PATH . '/class/xoopsformloader.php';
    $token      = new \XoopsFormHiddenToken();
    $token_form = $token->render();
    $xoopsTpl->assign('login_token', $token_form);
     //套用formValidator驗證機制
    $formValidator = new FormValidator('.myForm', true);
    $formValidator->render();
    
    $xoopsTpl->assign('stu_login', $stu_login);
    $xoopsTpl->assign('school_grade', $school_grade);
    $xoopsTpl->assign('school_class', $school_class);

}

function kw_leave_login_apply(){
    global $xoopsTpl;

    $stu_id = Request::getString('stuid'); //學號
    $Id = Request::getString('id');      //身分證字號
    $openid = Request::getString('openid');
    $anscheck = Request::getString('anscheck'); //驗證碼
    $grade = Request::getString('grade');
    $class = Request::getString('class');
    
    //XOOPS表單安全檢查
    if (!$GLOBALS['xoopsSecurity']->check()) {
        $error = implode('<br>', $GLOBALS['xoopsSecurity']->getErrors());
        $xoopsTpl->assign('error',$error);
        redirect_header($_SERVER['PHP_SELF'], 3, _MD_KWLEAVE_CHECK_ERROR); 
    }
    if($anscheck != $_SESSION['verify_num']) {//驗證碼錯誤
        redirect_header('index.php', 3, _MD_KWLEAVE_CHECK_ERROR); 
    }
    if(empty($stu_id) or empty($Id) or empty($grade) or empty($class)){
        redirect_header('index.php', 3, _MD_KWLEAVE_NEED_FIELD); //欄位沒寫
    }

    $stu_arr = Kw_leave::kw_leave_get_data('stu',$stu_id);
        
    if( $stu_arr['stu_uid'] != $Id or $stu_arr['stu_grade'] !=$grade or $stu_arr['stu_class'] !=$class){
        
        redirect_header('index.php', 3, _MD_KWLEAVE_FIELD_ERROR); //欄位錯誤
    }
    $_SESSION['stuID'] =$stu_arr['stu_uid'];
    $_SESSION['stu_id'] =$stu_arr['stu_id'];

}

function kw_leave_book_form($stu_id, $book_id = ''){
    global $xoopsTpl,$school_time,$today,$school_class,$school_grade,$xoopsDB,$xoopsModuleConfig;

    if(empty($stu_id)){
        redirect_header('index.php', 3, _MD_KWLEAVE_FORBBIDEN); //沒權限
    }
    $xoopsTpl->assign('book_warning', $xoopsModuleConfig['book_warning']);
    $xoopsTpl->assign('today', $today);
    $stu_arr = Kw_leave::kw_leave_get_data('stu',$stu_id);//取得學生資訊
    $stu_json = json_decode($stu_arr['stu_json'], true);
    $xoopsTpl->assign('stu_id', $stu_id);
    $xoopsTpl->assign('stu', $stu_arr);
    $xoopsTpl->assign('stu_json', $stu_json);

    $xoopsTpl->assign('stu_grade', $school_grade[$stu_arr['stu_grade']]);//年級
    $xoopsTpl->assign('stu_class', $school_class[$stu_arr['stu_class']]);//班級
    $xoopsTpl->assign('school_time', $school_time); //節數
    // var_dump($stu_arr);
    //假別 
    $cate_arr = Kw_leave::kw_leave_get_allTitle('cate');
    $xoopsTpl->assign('cate_arr', $cate_arr);
    $semester_arr = kw_leave_getSemester();
    $xoopsTpl->assign('semester_arr', $semester_arr);

    //判斷修改or新增(取預設值)
    if (!empty($book_id)) {
        $DBV = Kw_leave::kw_leave_get_data('book', $book_id);
        list($img_arr) = Kw_leave::kw_leave_get_data('img', '', 'book_id', $book_id);
        // var_dump($img_arr);
        $xoopsTpl->assign('book_id', $book_id);
        $book_json = json_decode($DBV['book_json'] , true);//str
        $book_desc  = $book_json['book_desc'];
        
        if($img_arr['img_type'] == 'upload'){
            $book_sign  = "<a href='". XOOPS_URL. $img_arr['img_content']. "' target='_blank'><img src='". XOOPS_URL . $img_arr['img_content'] . "'  alt='家長簽名' title='家長簽名' style='width:200px; height:100px'> </a>";
        }else if($img_arr['img_type'] == 'sign'){
            $book_sign  =  "<img src='{$img_arr['img_content']}'  alt='家長簽名' title='家長簽名' style='width:200px; height:100px'>";
        }
        $xoopsTpl->assign('book_sign', $book_sign);

    } else {
        $DBV      = [];
        $book_id = '';
    }
    
    //設定 cate_id 欄位的預設值
    $cate_id = !isset($DBV['cate_id']) ? '' : $DBV['cate_id'];
    $xoopsTpl->assign('cate_id', $cate_id);
    //設定 book_title欄位的預設值
    $book_title = !isset($DBV['book_title']) ? '' : $DBV['book_title'];
    $xoopsTpl->assign('book_title', $book_title);
    
    //設定 book_year 欄位的預設值 semester
    $book_year = !isset($DBV['book_year']) ?  $semester_arr['year'] : $DBV['book_year'];
    $xoopsTpl->assign('book_year', $book_year);
    
    
    //設定 請假日期 欄位的預設值
    $book_dt_start = !isset($DBV['book_dt_start']) ? '' : $DBV['book_dt_start'];
    $xoopsTpl->assign('book_dt_start', $book_dt_start);
    $book_dt_end = !isset($DBV['book_dt_end']) ? '' : $DBV['book_dt_end'];
    $xoopsTpl->assign('book_dt_end', $book_dt_end);
    list($date, $s_time) = explode(' ', $book_dt_start);
    list($date, $e_time) = explode(' ', $book_dt_end);
    
    $xoopsTpl->assign('book_class_start', $s_time-7 );
    $xoopsTpl->assign('book_class_end', $e_time-8);

    //設定 book_number 欄位的預設值
    $book_number = !isset($DBV['book_number']) ? '' : $DBV['book_number']; //float
    $xoopsTpl->assign('book_number', $book_number);
    
    
    //所見即所得編輯器
    $ck = new CkEditor('kw_leave', 'book_desc', $book_desc);
    $ck->setHeight(80);
    $ck->setToolbarSet('tadSimple');
    $editor = $ck->render();
    $xoopsTpl->assign('book_desc_editor', $editor);
    
    //引入日期
    $cal = new My97DatePicker();
    $cal::render();
    
    //加入Token安全機制
    require_once XOOPS_ROOT_PATH . '/class/xoopsformloader.php';
    $token      = new \XoopsFormHiddenToken('XOOPS_TOKEN', 360);
    $xoopsTpl->assign('book_token', $token->render());
    //套用formValidator驗證機制
    $formValidator = new FormValidator('.myForm', true);
    $formValidator->render();

    //線上簽名需要的資訊
    $sql = "select max(`book_id`) from `" . $xoopsDB->prefix('kw_leave_book')."` ";
    $result = $xoopsDB->query($sql) or Utility::web_error($sql);
    list($bid) = $xoopsDB->fetchRow($result);
    $bid++; //有危險性!!有可能會不一致

    $xoopsTpl->assign('bid', $bid);
}

function kw_leave_book_insert()
{
    global $xoopsDB,$kw_leave_uid;
    
    //檢查權限
    if(empty($_SESSION['stu_id']) || empty($kw_leave_uid)){
        redirect_header($_SERVER['PHP_SELF'], 3, _MD_KWLEAVE_FORBBIDEN); //沒權限
    }
    // //XOOPS表單安全檢查
    if (!$GLOBALS['xoopsSecurity']->check()) {
        $error = implode('<br>', $GLOBALS['xoopsSecurity']->getErrors());
        redirect_header($_SERVER['PHP_SELF'], 3, "安全性表單錯誤");
    }
    //檢查book_desc
    $book_desc = Request::getString('book_desc');
    if(empty($book_desc) ){
        redirect_header($_SERVER['PHP_SELF'], 3, "沒有請假事由"); 
        exit;
    }
    //檢查簽名
    $img  = Request::getString('book_img');
    // die( $img);
    if(empty($_FILES['file']['tmp_name']) && empty($img)){
        redirect_header($_SERVER['PHP_SELF'], 3, "沒有家長簽名"); 
        exit;
    }
    

    //取得相關資訊
    $semester_arr = kw_leave_getSemester();
    $process_arr = Kw_leave::kw_leave_get_data('process');
    $office_arr = Kw_leave::kw_leave_get_allTitle('office');
    
    //過濾資料
    $myts = \MyTextSanitizer::getInstance();
    $stu_id         = $_SESSION['stu_id'];
    $stu_arr        = Kw_leave::kw_leave_get_data('stu',$stu_id);

    $stu_json_arr   = json_decode($stu_arr['stu_json'],true); //家長資訊{stu_parent:,stun_contact,}
    $class_id       = $stu_arr['class_id'];
    $class_arr      = Kw_leave::kw_leave_get_data('class', $class_id);
    $class_teacher  = $class_arr['class_teacher'];//導師名{Tname:}
    $class_teacher_uid=$class_arr['class_teacher_uid'];
    
    $book_title     = $myts->addSlashes(Request::getString('book_title'));
    $book_year      = $semester_arr['this_year'];
    $cate_id        = Request::getInt('cate_id');
    $book_isenable  = Request::getInt('book_isenable');
    

    $book_dt_update = date('Y-m-d H:i:s');
    $book_mode      = Request::getString('book_mode');
    if($book_mode == 'day'){
        $book_dt_start  = Request::getString('book_dt_start');
        $book_dt_end  = Request::getString('book_dt_end');
        //檢查此段時間是否已請假
        if(kw_leave_time_isRepeat($stu_id, $book_dt_start,$book_dt_end)){
            redirect_header($_SERVER['PHP_SELF'], 3, "錯誤，此段時間已請假!"); 
            exit;
        }
        list($book_number, $book_str)= kw_leave_chk_time($book_dt_start,$book_dt_end);

    }else if($book_mode == 'class'){
        $book_class_start  = Request::getString('book_class_start');
        $book_class_end  = Request::getString('book_class_end');
        $book_date = Request::getString('book_dt_start');
        //檢查此段時間是否已請假
        if(kw_leave_time_isRepeat($stu_id, $book_class_start,$book_class_end)){
            redirect_header($_SERVER['PHP_SELF'], 3, "錯誤，此段時間已請假!"); 
            exit;
        }
        list($book_number, $book_str)= kw_leave_chk_class($book_class_start,$book_class_end );
        $book_dt_start  = $book_date ." ".($book_class_start+7).":00:00";
        $book_dt_end    = $book_date ." ".($book_class_end+8).":00:00";
        // die( $book_dt_start);
    }
    $book_desc      = $myts->addSlashes($book_desc);
    $json_parent    = $myts->addSlashes(Request::getString('stu_parent'));
    $json_contact   = $myts->addSlashes(Request::getString('stu_contact'));
    $json_email     = $myts->addSlashes(Request::getString('stu_email'));
    //更新學生資訊
    $stu_json ="{ \"stu_parent\":\"{$json_parent}\", \"stu_contact\":\"{$json_contact}\", \"stu_email\":\"{$json_email}\"}";
    $sql = 'update `'.$xoopsDB->prefix('kw_leave_stu')."` SET `stu_total`=`stu_total`+{$book_number}, `stu_json`='{$stu_json}' WHERE `stu_id` = '{$stu_id}' ";
    $xoopsDB->queryF($sql) or Utility::web_error($sql);
    
    $sql = 'insert into `' . $xoopsDB->prefix('kw_leave_book') . "` (
        `book_title`,
        `book_year`,
        `cate_id`,
        `stu_id`,
        `book_json`,
        `book_number`,
        `book_dt_start`,
        `book_dt_end`,
        `book_dt_update`,
        `book_sort`,
        `book_isenable`,
        `book_isresult`,
        `book_isfinish`
    ) values(
        '{$book_title}',
        '{$book_year}',
        '{$cate_id}',
        '{$stu_id}',
        '', 
        '{$book_number}',
        '{$book_dt_start}',
        '{$book_dt_end}',
        '{$book_dt_update}',
        '0',
        '{$book_isenable}',
        '0',
        '0'
    )"; //book_json 後面再更新
    $xoopsDB->query($sql) or Utility::web_error($sql);
    $book_id = $xoopsDB->getInsertId();

    //上傳和新增sign
    if($book_id && !empty($img)){
        Kw_leave::kw_leave_imgSigned($book_id , $img); //回傳sign_img檔名
    }else if($book_id && is_uploaded_file($_FILES['file']['tmp_name'])){
        Kw_leave::kw_leave_imgUpload($book_id); //回傳sign_img檔名
    }else{
        if($book_id){//上傳失敗 刪除請假資訊
            $sql = 'delete from `' . $xoopsDB->prefix('kw_leave_book') . "` 
            WHERE `book_id` = '{$book_id}' ";
            $xoopsDB->queryF($sql) or Utility::web_error($sql);
        }
        //回報新增資料失敗
        redirect_header('index.php', 3, _MD_KWLEAVE_ERROR); 
        exit;
    }

    //update book_json 更新請假資訊
    $book_json = "{\"book_num\":\"{$book_str}\", \"book_desc\":\"{$book_desc}\", \"stu_parent\":\"{$json_parent}\", \"stu_contact\":\"{$json_contact}\", \"stu_email\":\"{$json_email}\",\"class_id\":\"{$class_id}\", \"class_teacher\":\"{$class_teacher}\"}";

    $sql = 'update `' . $xoopsDB->prefix('kw_leave_book') . "` SET 
    `book_json` = '{$book_json}'  WHERE `book_id` = '{$book_id}' ";
    $xoopsDB->queryF($sql) or Utility::web_error($sql);

    //insert sign
    $sign_json = "{\"sign_office\":\"導師\",\"sign_job\":\"班級導師\",\"sign_name\":\"{$class_teacher}\"}";
    $sign_code = kw_leave_getKey(10);
    $code = $sign_code;
    //加入班級導師的簽核欄位
    $sql = 'insert into `' . $xoopsDB->prefix('kw_leave_sign') . "`(
        `book_id`, `sign_uid`,`sign_sort`,`sign_time`,`sign_year`,`sign_json`, `sign_code`
    ) values(
        '{$book_id}',
        '{$class_teacher_uid}',
        '0',
        null,
        '{$semester_arr['this_year']}',
        '{$sign_json}',
        '{$sign_code}'
    )";
    $xoopsDB->query($sql) or Utility::web_error($sql);
    $sign_id = $xoopsDB->getInsertId();

    //各處室流程簽核欄位
    foreach($process_arr as $key=>$arr){
        if($arr['process_isenable']==1){ //啟用的流程
            $office_id = $arr['office_id'];
            $arr_u = Kw_leave::kw_leave_get_userByUid($arr['process_uid']);
            $sign_json = "{\"sign_office\":\"{$office_arr[$office_id]}\", \"sign_job\":\"{$arr['process_title']}\",\"sign_name\":\"{$arr_u['name']}\"}";
            $sign_code  =   kw_leave_getKey(10);
            $sql = 'insert into `' . $xoopsDB->prefix('kw_leave_sign') . "`(
                `book_id`,
                `sign_uid`,
                `sign_sort`,
                `sign_time`,
                `sign_year`,
                `sign_json`,
                `sign_code`
            ) values(
                '{$book_id}',
                '{$arr['process_uid']}',
                '{$arr['process_sort']}',
                null,
                '{$semester_arr['this_year']}',
                '{$sign_json}',
                '{$sign_code}'
            )";
            $xoopsDB->query($sql) or Utility::web_error($sql);
        }
    }

    $book_arr = ['book_id'=>$book_id,'book_title'=>$book_title, 'dt_start'=>$book_dt_start, 'dt_end'=>$book_dt_end, 'parent_email'=>$json_email, 'sign_id'=>$sign_id,'sign_code'=>$code, 'sign_sort'=>0, 'uid'=>$class_teacher_uid, 'mail_order'=>'start'];
    //寄信通知
    list($isMailToP,$msg_p) = Kw_leave_SendMail($book_arr,'parent');
    list($isMailToT,$msg_t) = Kw_leave_SendMail($book_arr,'teacher');

    if($isMailToP && $isMailToT){
        redirect_header('book.php', 3, "新增假單成功，".$msg_p.$msg_t); 
        exit;
    }else{
        redirect_header('book.php', 3, "新增假單成功，寄送郵件通知失敗!"); 
        exit;
    };
    
}

function kw_leave_book_update($book_id)
{
    global $xoopsDB, $iskwLeaveAdmin;

    //檢查權限
    if (!$iskwLeaveAdmin && empty($_SESSION['stu_id'])) {
        redirect_header('index.php', 3, _MD_KWLEAVE_FORBBIDEN);
    }

    //XOOPS表單安全檢查
    if (!$GLOBALS['xoopsSecurity']->check()) {
        $error = implode('<br>', $GLOBALS['xoopsSecurity']->getErrors());
        redirect_header($_SERVER['PHP_SELF'], 3, $error);
    }
    
    if(Kw_leave::kw_leave_sign_check($book_id)){
        redirect_header("{$_SERVER['PHP_SELF']}", 3, "此假單已經開始簽核無法修改!");
        exit;
    }

    $myts = \MyTextSanitizer::getInstance();
    $book_id        = Request::getInt('book_id');
    $stu_id         = $_SESSION['stu_id'];
    $cate_id        = Request::getInt('cate_id');
    $book_isenable  = Request::getInt('book_isenable');
    $book_dt_update = date('Y-m-d H:i:s');
    $book_mode      = Request::getString('book_mode');
    $book_number_old    = Request::getFloat('book_number');//float

    if($book_mode == 'day'){
        $book_dt_start  = Request::getString('book_dt_start');
        $book_dt_end  = Request::getString('book_dt_end');
        //檢查此段時間是否已請假
        if(kw_leave_time_isRepeat($stu_id, $book_dt_start,$book_dt_end, $book_id)){
            redirect_header($_SERVER['PHP_SELF'], 3, "錯誤，此段時間已請假!"); 
            exit;
        }
        list($book_number, $book_str)= kw_leave_chk_time($book_dt_start,$book_dt_end);
    }else if($book_mode == 'class'){
        $book_class_start  = Request::getString('book_class_start');
        $book_class_end  = Request::getString('book_class_end');
        $book_date = Request::getString('book_dt_start');
        //檢查此段時間是否已請假
        if(kw_leave_time_isRepeat($stu_id, $book_class_start,$book_class_end,$book_id)){
            redirect_header($_SERVER['PHP_SELF'], 3, "錯誤，此段時間已請假!"); 
            exit;
        }
        list($book_number, $book_str)= kw_leave_chk_class($book_class_start,$book_class_end );
        list($book_date, $time) = explode(' ', $book_date);//只取日期部分
        $book_dt_start  = $book_date  ." ".($book_class_start+7).":00:00";
        $book_dt_end    = $book_date  ." ".($book_class_end+8).":00:00";
    }
    
    $book_desc      = $myts->addSlashes(Request::getString('book_desc'));
    $json_parent    = $myts->addSlashes(Request::getString('stu_parent'));
    $json_contact   = $myts->addSlashes(Request::getString('stu_contact'));
    $json_email     = $myts->addSlashes(Request::getString('stu_email'));
    $arr= Kw_leave::kw_leave_get_fieldById('book',$book_id, 'book_json');    
    $book_json_arr  = json_decode($arr['book_json'],true);

     // update book_json
    $book_json = "{\"book_num\":\"{$book_str}\", \"book_desc\":\"{$book_desc}\", \"stu_parent\":\"{$json_parent}\", \"stu_contact\":\"{$json_contact}\", \"stu_email\":\"{$json_email}\",\"class_id\":\"{$book_json_arr['class_id']}\", \"class_teacher\":\"{$book_json_arr['class_teacher']}\"}";
    
    $sql = 'update `' . $xoopsDB->prefix('kw_leave_book') . "` SET 
    `cate_id`       = '{$cate_id}',
    `book_number`    = '{$book_number}',
    `book_dt_start`  = '{$book_dt_start}',
    `book_dt_end`    = '{$book_dt_end}',
    `book_json`      = '{$book_json}',
    `book_dt_update` = '{$book_dt_update}',
    `book_isenable`  = '{$book_isenable}'  
    WHERE `book_id` = '{$book_id}' ";
    $xoopsDB->queryF($sql) or Utility::web_error($sql);

    //update 學生家長資訊 學生資訊
    $stu_json ="{ \"stu_parent\":\"{$json_parent}\", \"stu_contact\":\"{$json_contact}\", \"stu_email\":\"{$json_email}\"}";
    if($book_number_old == $book_number)
        $sql = 'update `' . $xoopsDB->prefix('kw_leave_stu') . "` SET  `stu_json` = '{$stu_json}' WHERE `stu_id` = '{$stu_id}' ";
    else
        $sql = 'update `'.$xoopsDB->prefix('kw_leave_stu')."` SET `stu_total`=`stu_total`+{$book_number}-{$book_number_old} , `stu_json`='{$stu_json}' WHERE `stu_id` = '{$stu_id}' ";
    $xoopsDB->queryF($sql) or Utility::web_error($sql);
    
    //更新簽名
    $img  = Request::getString('book_img');
    if(!empty($_FILES['file']['name'])){
        kw_leave::kw_leave_imgUpload($book_id);//回傳sign_img檔名
    }else if(!empty($img)){
        kw_leave::kw_leave_imgSigned($book_id , $img);//回傳sign_img檔名
    }
    return $book_id;
}


