<?php
/*-----------引入檔案區--------------*/
use Xmf\Request;
use XoopsModules\Kw_leave\Kw_leave;
use XoopsModules\Tadtools\Utility;
use XoopsModules\Tadtools\SweetAlert;
//use XoopsModules\Tadtools\FormValidator;
//use XoopsModules\Tadtools\CkEditor;
//use XoopsModules\Tadtools\My97DatePicker;

require_once __DIR__ . '/header.php';
$xoopsOption['template_main'] = 'kw_leave_sign.tpl';
require_once XOOPS_ROOT_PATH . '/header.php';

if (!$iskwLeaveMaster && !$iskwLeaveCheck && !$iskwLeaveAdmin ) {
    redirect_header('index.php', 3, _MD_KWLEAVE_FORBBIDEN);
    exit;
}


/*-----------執行動作判斷區----------*/
require_once $GLOBALS['xoops']->path('/modules/system/include/functions.php');
$op        = Request::getString('op');
$book_id   = Request::getInt('book_id');  //假單
$stu_id    = Request::getString('stu_id');  //申請者
$review    = Request::getString('review');  //瀏覽模式
$value     = Request::getString('value');  //瀏覽模式
$job       = Request::getString('job');  //瀏覽模式
$show_PageBar   = Request::getBool('show_PageBar'); //頁次
$today = date('Y-m-d');

switch ($op) {
        
    case 'kw_leave_sign_ok': //ajax
        $sign_id   = Request::getInt('id');  //假單
        $user_uid   = Request::getInt('user');
        $msg = kw_leave_sign_update($sign_id, $user_uid, 1); //1:核准(is_agree)
        //$msg="ok";
        die($msg);
        exit;

    case 'kw_leave_sign_deny': //ajax
        $sign_id   = Request::getInt('id');
        $user_uid  = Request::getInt('user');
        $msg = kw_leave_sign_update($sign_id,  $user_uid, 0 );//0:退回(is_agree) 
        //$msg="deny";
        die($msg);
        exit;

    // case 'kw_leave_sign': //啟用或停用假單
    //     $book_isenable     = system_CleanVars($_REQUEST, 'book_isenable', '', 'int');
    //     kw_leave_update_isenable('book', $book_id, $book_isenable);
    //     header("location: {$_SERVER['PHP_SELF']}");
    //     break;

    default:
        // var_dump($job);
        kw_leave_sign_list( $job );
        $op = 'kw_leave_sign_list';
}

/*-----------秀出結果區--------------*/
$xoopsTpl->assign('op', $op);
$xoopsTpl->assign("toolbar", Utility::toolbar_bootstrap($interface_menu,false,$interface_icon));
$xoopsTpl->assign('today', $today);
$xoopsTpl->assign('uid', $kw_leave_uid);
$xoopsTpl->assign('iskwLeaveAdmin', $iskwLeaveAdmin);
$xoopsTpl->assign('iskwLeaveCheck', $iskwLeaveCheck);
$xoopsTpl->assign('iskwLeaveMaster', $iskwLeaveMaster);
$xoTheme->addStylesheet(XOOPS_URL . '/modules/kw_leave/assets/css/module.css');
$xoTheme->addStylesheet(XOOPS_URL . '/modules/tadtools/css/vtable.css');
require_once XOOPS_ROOT_PATH . '/footer.php';

/*-----------function區--------------*/


function kw_leave_sign_list( $job='')
{
    global $iskwLeaveCheck, $iskwLeaveAdmin,$iskwLeaveMaster, $kw_leave_uid;
    global $xoopsDB, $xoopsTpl,$xoopsUser;

    //檢查權限
    if (!$iskwLeaveAdmin && !$iskwLeaveCheck && !$iskwLeaveMaster) {
        redirect_header($_SERVER['PHP_SELF'], 3, _MD_KWLEAVE_FORBBIDEN);
        exit;
    }
    //取得其他資訊
    $myName = $xoopsUser->name();
    $xoopsTpl->assign('myName', $myName);
    $semester_arr = kw_leave_getSemester();
    $this_year = $semester_arr['this_year'];
    $xoopsTpl->assign('semester_arr', $semester_arr);
    $cate_arr  = Kw_leave::kw_leave_get_allTitle('cate');
    $xoopsTpl->assign('cate_arr', $cate_arr);
    $process_arr = Kw_leave::kw_leave_get_allTitle('process');
    $xoopsTpl->assign('process_arr', $process_arr);
    //for select year
    $all_year_arr = [$semester_arr['this_year'],$semester_arr['this_year']-1,$semester_arr['this_year']-2]; //提供三年內查詢
    $xoopsTpl->assign('all_year_arr',  $all_year_arr);

    // $myts = \MyTextSanitizer::getInstance();
    // $sign_year = empty($sign_year) ? $this_year : $myts->htmlSpecialChars($sign_year);
    // $review = empty($review) ? 'sign' : $myts->htmlSpecialChars($review);
    // $value =$myts->htmlSpecialChars($value);
    
    
    //取得流程簽核序
    $sign_sort=[];
    $job_arr = []; //正式身分
    if($iskwLeaveMaster){//導師(唯一)
        $class_arr = Kw_leave::kw_leave_get_dataByUid($kw_leave_uid,'teacher');
        $class_id = $class_arr['class_id'];
        $class_title=$class_arr['class_title'];
        // var_dump($class_arr);
        //$xoopsTpl->assign('class_arr', $class_arr);
        array_push($sign_sort,0);
        $job_arr [0] = '導師';
        $isMaster=true;
    }
    if($iskwLeaveCheck){ //審核者(唯一)
        $check_arr = Kw_leave::kw_leave_get_fieldByUid('process', $kw_leave_uid, '*');
        $check_sort = $check_arr['process_sort'];
        array_push($sign_sort, $check_sort);// 將簽核序放進sign_sort array的最後一個
        $job_arr [$check_sort] = $check_arr['process_title'];
        //職代檢查 是否有職代身分
        $iskwLeaveBackup = ($backup_arr = Kw_leave::kw_leave_get_dataByUid($kw_leave_uid,'backup')) ? true : false;
    }
    $xoopsTpl->assign('job_arr',  $job_arr);
    //有職代身分(多位)
    if($iskwLeaveBackup){
        $backup_sort=[];
        foreach($backup_arr as $k => $arr){
            // $backup_sort [] = $arr['process_sort'];
            array_push($backup_sort, $arr['process_sort']);
            $backup_job_arr [$arr['process_sort']] =  $arr['process_title'];
        }
        $xoopsTpl->assign('backup_job_arr',  $backup_job_arr);
    }   
    // var_dump($job_arr);
    //預設身分
    if(empty($job)){
        $sort_key = array_key_first($job_arr); //取得第一個元素的key(sort)
        $job = $job_arr[$sort_key];
        //var_dump( $job);
    }else{
        if(in_array($job, $job_arr)){
            $sort_key = array_search($job, $job_arr); 
            $isBackup = false;
        }
        else if(in_array($job, $backup_job_arr)){
            $sort_key = array_search($job, $backup_job_arr); 
            $isBackup = true;
        }
        else{
            redirect_header($_SERVER['PHP_SELF'], 3, "職務錯誤，沒有簽核資格!");
            exit;
        }
    }
    // var_dump($job);
    if($job == '導師')
        $xoopsTpl->assign('class_title',  $class_title);
    else
        $xoopsTpl->assign('class_title', '');

    $xoopsTpl->assign('job', $job);
    
  
    
    //取得搜尋語法
    // if (!empty($year)) { //no year
    //     if (!empty($cate)){ //假別
    //         if (!empty($isfinish)){
    //             if($isfinish == 2)//已簽核退回
    //                 $search = " and a.`sign_isfinish`='1' and a.`book_isresult`='0' and a.`cate_id`='{$cate}' and a.`book_year`='{$year}' ORDER BY a.`book_id` desc";
    //             else if($isfinish == 1) //已簽核同意
    //                 $search = " and a.`book_isfinish`='1' and a.`book_isresult`='1' and a.`cate_id`='{$cate}' and  a.`book_year`='{$year}' ORDER BY a.`book_id` desc";
    //             else if($isfinish == 3) //簽核中
    //                 $search = " and a.`book_isfinish`='0' and a.`cate_id`='{$cate}' and a.`book_year`='{$year}' ORDER BY a.`book_id` desc";
    //         }else{
    //             $search = " and a.`cate_id`='{$cate}' and a.`book_year`='{$year}' ORDER BY a.`book_id` desc";
    //         }
    //     }else{
    //         $search = " and a.`book_year`='{$year}' ORDER BY a.`book_id` desc";
    //     } 
    // }else{
    //     $year = $this_year;
    //     $search = " and a.`book_year`='{$year}' ORDER BY a.`book_id` desc";
    // }

    $year   = Request::getString('year');  //瀏覽模式
    $sign   = Request::getString('sign');  //瀏覽模式
    //取得搜尋語法
    if (!empty($year)) { 
        if (!empty($sign)) { //審核狀態   
            
            if( $sign == 2) //已核
                $search = " and b.`sign_sort`='{$sort_key}' and b.`sign_time` IS NOT NULL and b.`sign_year`='{$year}' order by a.`book_dt_update` desc";
            else if($sign == 1 ) //未核
                $search = " and b.`sign_sort`='{$sort_key}' and a.`book_isfinish`= '0' and b.`sign_time` IS NULL and b.`sign_year`='{$year}' order by a.`book_dt_update` desc";    
            else //全部
                $search = " and b.`sign_sort`='{$sort_key}' and b.`sign_year`='{$year}' order by a.`book_dt_update` desc";      
            
            // $search = " and b.`sign_sort`='{$sort_key}' and a.`book_isfinish`= '0' and b.`sign_time` IS NULL and b.`sign_year`='{$year}' order by a.`book_dt_update` desc";    
            }else  $search = " and b.`sign_year`='{$year}' order by a.`book_dt_update` desc";
            
    }else{
        $year = $this_year;
        $search = " and b.`sign_year`='{$year}' ORDER BY a.`book_id` desc";
    }
     //選單
     $xoopsTpl->assign('sign', $sign);
     $xoopsTpl->assign('year', $year);
    
    if($job == "導師"){ //導師
        $sql = 'select c.`class_id`, d.`stu_id`, a.*, b.*, e.* from `' . $xoopsDB->prefix('kw_leave_class') . '` as c join `' . $xoopsDB->prefix('kw_leave_stu'). '` as d join `'. $xoopsDB->prefix('kw_leave_book') ."` as a join `". $xoopsDB->prefix('kw_leave_sign') . '` as b join `' . $xoopsDB->prefix('kw_leave_img') . "` as e on c.`class_id` = d.`class_id` and d.`stu_id`= a.`stu_id` and a.`book_id`= b.`book_id` and e.`book_id`= a.`book_id` where c.`class_id`='{$class_id}' and `book_isenable`='1' {$search}";
    }
    else{
        //單一身分確認
        if(!$isBackup)
            $search = " and `sign_uid`='{$kw_leave_uid}' " . $search;
        
        $sql = 'select a.*, b.*, e.* from `' . $xoopsDB->prefix('kw_leave_book') . '` as a join `' . $xoopsDB->prefix('kw_leave_sign') . '` as b join `' . $xoopsDB->prefix('kw_leave_img') . "` as e on a.`book_id` = b.`book_id` and e.`book_id`= a.`book_id` where `book_isenable`='1' {$search}";
    }
    // die($sql);
    //getPageBar($原sql語法, 每頁顯示幾筆資料, 最多顯示幾個頁數選項);
    $PageBar = Utility::getPageBar($sql, 10, 20);
    $bar     = $PageBar['bar'];
    $sql     = $PageBar['sql'];
    $total   = $PageBar['total'];    
    $xoopsTpl->assign('bar', $bar);
    $xoopsTpl->assign('total', $total);
   

    
    $result = $xoopsDB->query($sql) or Utility::web_error($sql);
    $all_book = [];
    $i = 0;
    while (false !== ($all = $xoopsDB->fetchArray($result))) {
        foreach ($all as $k => $v) {
            $$k = $v; 
        }
        // var_dump($v);
        $all_book[$i]['sign_id']        = (int) $sign_id;
        $all_book[$i]['sign_time']      = (int) $sign_time;
        $all_book[$i]['sign_code']   = (int) $sign_code;
        $all_book[$i]['sign_sort']   = (int) $sign_sort;
        $sign_json_arr   =  json_decode($sign_json,true);
        $all_book[$i]['sign_office']  =$sign_json_arr['sign_office'];
        $all_book[$i]['sign_job']  =$sign_json_arr['sign_job'];
        $all_book[$i]['sign_name']  =$sign_json_arr['sign_name'];
        
        $all_book[$i]['book_id']        = (int) $book_id;
        $all_book[$i]['book_title']     = $book_title;
        $all_book[$i]['cate_id']        = (int) $cate_id;
        $all_book[$i]['cate_title']     = $cate_arr[$cate_id];
        $all_book[$i]['stu_id']         = $stu_id;
        $all_book[$i]['book_number']    = (int) $book_number;

        $all_book[$i]['img_content']    =  $img_type=="sign" ? "<img src='{$img_content}'  alt='家長簽名' title='家長簽名' style='width:80px; height:50px'>" : "<a href='{$img_content}' target='_blank'><img src='{$img_content}'  alt='家長簽名' title='家長簽名' style='width:80px; height:50px'> </a>";

        $book_json_arr   = json_decode($book_json, true);
        // $sign_img     =  $book_json_arr['sign_img'];
        // $all_book[$i]['sign_img']       = "<a href='".XOOPS_URL."/uploads/kw_leave/book/{$sign_img}' target='_blank'><img src='". XOOPS_URL . "/uploads/kw_leave/book/{$sign_img}'  alt='家長簽名' title='家長簽名' style='width:80px; height:50px'> </a>";
        $all_book[$i]['book_num']       =  $book_json_arr['book_num'];
        $all_book[$i]['book_desc']      =  $book_json_arr['book_desc'];
        $all_book[$i]['stu_parent']     =  $book_json_arr['stu_parent'];
        $all_book[$i]['stu_contact']    =  $book_json_arr['stu_contact'];
        $all_book[$i]['stu_email']      =  $book_json_arr['stu_email'];
        $all_book[$i]['class_id']       =  $book_json_arr['class_id'];
        $all_book[$i]['class_teacher']  =  $book_json_arr['class_teacher'];
        
        $all_book[$i]['book_dt_start'] = $book_dt_start;
        $all_book[$i]['book_dt_end']   = $book_dt_end;
        $all_book[$i]['book_dt_update'] = $book_dt_update;
        $all_book[$i]['book_sort']       = (int) $book_sort;
        $all_book[$i]['book_isresult']     = (int) $book_isresult;
        $all_book[$i]['book_isfinish']     = (int) $book_isfinish;
        $all_book[$i]['book_isfinish_pic'] = $book_isfinish ? '<img src="' . XOOPS_URL . '/modules/kw_leave/assets/images/o.png" style="width:25%;height:25%" alt="已完成" title="已完成">' : '<img src="' . XOOPS_URL . '/modules/kw_leave/assets/images/x.png" style="width:25%;height:25%" alt="未完成" title="未完成">';

        $sign_arr = Kw_leave::kw_leave_get_data('sign','','book_id',$book_id);
        $all_book[$i]['sign_arr'] = $sign_arr;

        // var_dump($all);
        $i++;
    }
    $xoopsTpl->assign('all_book', $all_book);

    // var_dump($sql);
}

function kw_leave_sign_update($sign_id, $user_uid, $isAgree)
{
    global $iskwLeaveCheck, $iskwLeaveAdmin,$iskwLeaveMaster,$xoopsUser;
    
    //檢查權限
    if (!$iskwLeaveAdmin && !$iskwLeaveCheck && !$iskwLeaveMaster) {
        return _MD_KWLEAVE_FORBBIDEN;
    }
    //檢查資料
    if (empty($sign_id) or !isset($isAgree)) {
        return _MD_KWLEAVE_NEED_ID;
    }
    //確認合法uid
    $myuid = $xoopsUser->uid();
    if($user_uid != $myuid){
        return "uid不合法";
    }
    //簽核(funtion.php)
    return kw_leave_chk_sign($sign_id,$isAgree);
    
}
