<?php
/*-----------引入檔案區--------------*/
use Xmf\Request;
use XoopsModules\Kw_leave\Kw_leave;
use XoopsModules\Kw_leave\Kw_calendar;
use XoopsModules\Tadtools\Utility;
use XoopsModules\Tadtools\SweetAlert;
use XoopsModules\Tadtools\FormValidator;
use XoopsModules\Tadtools\CkEditor;
use XoopsModules\Tadtools\My97DatePicker;
require_once __DIR__ . '/header.php';
$xoopsOption['template_main'] = "kw_leave_statistic.tpl";
include_once XOOPS_ROOT_PATH . "/header.php";

/*--
教師統計介面
---*/
/*-----------執行動作判斷區----------*/
require_once $GLOBALS['xoops']->path('/modules/system/include/functions.php');
$op        = Request::getString('op');
$book_id   = Request::getInt('book_id');  //假單
$stu_id    = Request::getString('stu_id');  //申請者
// $job       = Request::getString('job');  //瀏覽模式
$show_PageBar   = Request::getBool('show_PageBar'); //頁次
$today =date('Y-m-d');


switch ($op) {
    default:
        kw_leave_statistic_list();
        $op = 'kw_leave_statistic_list';
}

/*-----------秀出結果區--------------*/
$xoopsTpl->assign('op', $op);
$xoopsTpl->assign("toolbar", Utility::toolbar_bootstrap($interface_menu,false,$interface_icon));
$xoopsTpl->assign('today', $today);
$xoopsTpl->assign('uid', $kw_leave_uid);
$xoopsTpl->assign('iskwLeaveAdmin', $iskwLeaveAdmin);
$xoopsTpl->assign('iskwLeaveCheck', $iskwLeaveCheck);
$xoopsTpl->assign('iskwLeaveMaster', $iskwLeaveMaster);
$xoTheme->addStylesheet(XOOPS_URL . '/modules/kw_leave/assets/css/module.css');
$xoTheme->addStylesheet(XOOPS_URL . '/modules/tadtools/css/vtable.css');
require_once XOOPS_ROOT_PATH . '/footer.php';

function kw_leave_statistic_list()
{
    global $iskwLeaveCheck, $iskwLeaveAdmin,$iskwLeaveMaster, $kw_leave_uid;
    global $xoopsDB, $xoopsTpl,$xoopsUser;

    //檢查權限
    if (!$iskwLeaveAdmin && !$iskwLeaveCheck && !$iskwLeaveMaster) {
        redirect_header($_SERVER['PHP_SELF'], 3, _MD_KWLEAVE_FORBBIDEN);
        exit;
    }
    $calendar = new Kw_calendar();
    $year = $calendar->getDate('year');
    $month= $calendar->getDate('month');
    $day = $calendar->getDate('day');
    $date=date("Y-m-d",mktime(0,0,0,$month,$day,$year));
    $xoopsTpl->assign("calendar", $calendar);
    $xoopsTpl->assign("year", $year);
    $xoopsTpl->assign("month", $month);
    $xoopsTpl->assign("day", $day);
    $xoopsTpl->assign("date", $date);
    // echo $calendar;
    //取得其他資訊
    $myName = $xoopsUser->name();
    $xoopsTpl->assign('myName', $myName);
    $cate_arr  = Kw_leave::kw_leave_get_allTitle('cate');
    $xoopsTpl->assign('cate_arr', $cate_arr);
    $semester_arr = kw_leave_getSemester();
    $this_year = $semester_arr['this_year'];
    $xoopsTpl->assign('semester_arr', $semester_arr);
    $startTime = $semester_arr['school_limit_start'];
    $endTime = $semester_arr['school_limit_end'];

    if($iskwLeaveMaster){//導師(唯一)
        //取得自己的班級
        $myClass = Kw_leave::kw_leave_get_dataByUid($kw_leave_uid,'teacher');
        $cid = $myClass['class_id'];
        $xoopsTpl->assign('myClass', $myClass); 
        $class_arr[$cid] = $myClass;
        $xoopsTpl->assign('class_arr', $class_arr);
    }
    else{ //審核者(多班)
        //取得已建立班級送到前端
        $class_arr = Kw_leave::kw_leave_get_data('class');
        $xoopsTpl->assign('class_arr',$class_arr);
    }//end if

    // echo $sql;
    $all_stu = [];
    foreach($class_arr as $class_id=>$arr){
        $sql = 'select c.`class_id`, s.*, b.* from `' . $xoopsDB->prefix('kw_leave_class') . '` as c join `' . $xoopsDB->prefix('kw_leave_stu'). '` as s join `'. $xoopsDB->prefix('kw_leave_book') ."` as b on c.`class_id` = s.`class_id` and s.`stu_id`= b.`stu_id` where c.`class_id`='{$class_id}' and `book_isenable`='1' and `book_year`='{$this_year}' and `book_dt_start`<= '{$date} {$endTime}' and `book_dt_end`>='{$date} {$startTime}'";
        // echo $sql;
        $result = $xoopsDB->query($sql) or Utility::web_error($sql);
        $i = 0;
        while (false !== ($all = $xoopsDB->fetchArray($result))) {
            foreach ($all as $k => $v) {
                $$k = $v; 
            }
            // var_dump($v);
            $all_stu[$class_id][$stu_id]['stu_id']           = $stu_id;
            $all_stu[$class_id][$stu_id]['stu_title']        = $stu_title;
            //$all_stu[$class_id][$stu_id]['stu_json_arr']     = json_decode($stu_json,true);
            $all_stu[$class_id][$stu_id]['cate_id']         = (int) $cate_id;
            $all_stu[$class_id][$stu_id]['cate_title']      = $cate_arr[$cate_id];
            $all_stu[$class_id][$stu_id]['book_dt_start']    = $book_dt_start;
            $all_stu[$class_id][$stu_id]['book_dt_end']      = $book_dt_end;
            $all_stu[$class_id][$stu_id]['book_isfinish']    = $book_isfinish;
            //$all_stu[$class_id][$stu_id]['book_isresult']    = $book_isresult;
            //$all_stu[$class_id][$stu_id]['book_json_arr']    = json_decode($book_json,true);
            $i++;
        }//end while
        $count_stu[$class_id]=$i;
    }//end foreach
    $xoopsTpl->assign("count_stu", $count_stu);
    $xoopsTpl->assign("all_stu", $all_stu);

}