
<style type="text/css">
  .panel{
    position: relative;
    z-index: 29;
    font-size: 20px;
    display: inline-block; 
    background-color:rgb(200,200,200);
    border: 2px solid black;
    border-radius: 7px;
    padding: 7px;
    margin:5px;
    color:white;
    max-width: 200px;
    max-height: 80px;
    word-wrap:break-word;
   
}
#canvas{  
    position: relative;
    z-index: 31;
}
#canvasDiv{
    position: relative;
    z-index: 30;
}
</style>



<div class="panel" id="canvasDiv"></div>
<button id="btn_clear">清除</button>
<button id="btn_submit">提交</button>
<img id="signimg"  />

<script language="javascript">
var canvasDiv = document.getElementById('canvasDiv');
var canvas = document.createElement('canvas');
//var screenwidth = (window.innerWidth > 0) ? window.innerWidth : screen.width;

var canvasWidth = 200;
var canvasHeight = 80;
document.addEventListener('touchmove', onDocumentTouchMove,  { passive: false });
var point = {};
point.notFirst = false;
canvas.setAttribute('width', canvasWidth);
canvas.setAttribute('height', canvasHeight);
canvas.setAttribute('id', 'canvas');
canvasDiv.appendChild(canvas);
if (typeof G_vmlCanvasManager != 'undefined') {
    canvas = G_vmlCanvasManager.initElement(canvas);
}
var context = canvas.getContext("2d");
/*var ptrn = context.createPattern(img, 'no-repeat');
context.fillStyle = ptrn;
context.fillRect(0, 0, canvas.width, canvas.height);
*/
var img = new Image();
//img.src = "Transparent.png";

img.onload = function() {
    var ptrn = context.createPattern(img, 'repeat');
    context.fillStyle = ptrn;
    context.fillRect(0, 0, canvas.width, canvas.height);
}
canvas.addEventListener("touchstart", function(e) {
    //console.log(e);
    //e.preventDefault();
    var mouseX = e.touches[0].pageX - this.offsetLeft;
    var mouseY = e.touches[0].pageY - this.offsetTop;
    paint = true;
    addClick(e.touches[0].pageX - this.offsetLeft, e.touches[0].pageY - this.offsetTop);
	//console.log(e.touches[0].pageX - this.offsetLeft, e.touches[0].pageY - this.offsetTop);
    redraw();
});

canvas.addEventListener("touchend", function(e) {
    //e.preventDefault();
	//console.log("touch end");
    paint = false;
});

canvas.addEventListener("touchmove", function(e) {
    //e.preventDefault();
    if (paint) {
		//console.log("touchmove");
        addClick(e.touches[0].pageX - this.offsetLeft, e.touches[0].pageY - this.offsetTop, true);
		//console.log(e.touches[0].pageX - this.offsetLeft, e.touches[0].pageY - this.offsetTop);
        redraw();
    }

});

canvas.addEventListener("mousedown", function(e) {
    //e.preventDefault();
    var mouseX = e.pageX - this.offsetLeft;
    var mouseY = e.pageY - this.offsetTop;
    paint = true;
    addClick(e.pageX - this.offsetLeft, e.pageY - this.offsetTop);
    redraw();
});
canvas.addEventListener("mousemove", function(e) {
    //e.preventDefault();
    if (paint) {
        addClick(e.pageX - this.offsetLeft, e.pageY - this.offsetTop, true);
        redraw();
    }
});
canvas.addEventListener("mouseup", function(e) {
    //e.preventDefault();
    paint = false;
});
canvas.addEventListener("mouseleave", function(e) {
    //e.preventDefault();
    paint = false;
});

$(document).ready(function () {
  //$("#signature").jSignature({ color: "#00f", lineWidth: 5, 'background-color': "#dcdcdc" });
  // 清除
  $('#btn_clear').click(function () {
      //$("#signature").jSignature('clear');
      canvas.width = canvas.width;
  });
  //存檔
  $('#btn_submit').click(function (e) {
      //e.preventDefault();
      $('#btn_submit').fadeOut(300);
      img = canvas.toDataURL("image/png");
      $("#signimg").attr("src", img);
      /*$.post('save.php', {'type': arr[0] , 'content': arr[1]} ,function (sn) {
          location.href = 'save.php';
          //location.href = 'show.php?sn=' + sn;
      });*/
      
      $.ajax({
        url : 'save.php',
        type : 'post',
        cache: false,
        //contentType : 'application/x-www-form-urlencoded; charset=UTF-8', // 不能用 'application/json; charset=utf-8'
        //'application/x-www-form-urlencoded; charset=UTF-8',
        data : {'type': 'img', 'img': img }, // 不用JSON.stringify()
        success: function() {
          //alert("成功:"+ data); // result是json物件
        },
        error: function(xhr) {
          alert("錯誤:"+xhr.error);
          }     
      });

  });

})


function onDocumentTouchStart(event) {
    if (event.touches.length == 1) {
        //event.preventDefault();
        // Faking double click for touch devices
        var now = new Date().getTime();
        if (now - timeOfLastTouch < 250) {
            reset();
            return;
        }
        timeOfLastTouch = now;
        mouseX = event.touches[0].pageX;
        mouseY = event.touches[0].pageY;
        isMouseDown = true;
    }

}

function onDocumentTouchMove(event) {
    if (event.touches.length == 1) {
        //event.preventDefault();
        mouseX = event.touches[0].pageX;
        mouseY = event.touches[0].pageY;
    }
}

function onDocumentTouchEnd(event) {
    if (event.touches.length == 0) {
        //event.preventDefault();
        isMouseDown = false;
    }
}


var clickX = new Array();
var clickY = new Array();
var clickDrag = new Array();
var paint;

function addClick(x, y, dragging)
{
    clickX.push(x);
    clickY.push(y);
    clickDrag.push(dragging);
}


function redraw() {

    //canvas.width = canvas.width; // Clears the canvas
    context.strokeStyle = "#df4b26";
    context.lineJoin = "round";
    context.lineWidth = 2;
    while (clickX.length > 0) {
        point.bx = point.x;
        point.by = point.y;
        point.x = clickX.pop();
        point.y = clickY.pop();
        point.drag = clickDrag.pop();
        context.beginPath();
        if (point.drag && point.notFirst) {
            context.moveTo(point.bx, point.by);
        } else {
            point.notFirst = true;
            context.moveTo(point.x - 1, point.y);
        }
        context.lineTo(point.x, point.y);
        context.closePath();
        context.stroke();
    }

}
</script>
