<div class="form-group row py-2 mx-4 mt-0 border bg-light">
    <div class="input-group input-group-sm mb-3">
        <form action="config.php" method="post" id="stu_delAll" class="myForm " role="form"> 
            <{$stu_token}> 
            <input type="hidden" name="op"  id="op" value="kw_leave_all_delete">
            <input type="hidden" name="isDel" id="isDel" value="1">
            <input type="hidden" name="type" id="type" value="stu">
            <button type="submit" data-toggle="tooltip" data-placement="top" data-bs-toggle="tooltip" data-bs-placement="top" title="僅可於暑假期間使用" alt="僅可於暑假期間使用" <{if !$isDelAll}> class="btn-sm btn-secondary" disabled <{else}>class="btn-sm btn-danger" <{/if}> >刪除全校學生</button>
        </form>
        <a href="./assets/doc/stu.csv"  class="input-group-text"  data-toggle="tooltip" data-placement="top" data-bs-placement="top" data-bs-toggle="tooltip" data-bs-placement="top"  title="學生資料上傳格式範例">下載匯入範例</a>
    </div>
    <div class="input-group input-group-sm mb-3">
        <button type="button" id="upgrade" name="<{$uid}>" data-toggle="tooltip" data-placement="top" data-bs-toggle="tooltip" data-bs-placement="top" title="僅可於暑假期間使用" alt="僅可於暑假期間使用" <{if !$isDelAll}> class="btn-sm btn-secondary" disabled <{else}>class="btn-sm btn-warning" <{/if}> >學生年級升級</button>
        <{$stu_token}> 
        <label class="input-group-text">請注意!!幼兒園不升級!!</label>
        <label class="input-group-text">學生年級超出設定範圍會自動刪除!!</label>
    </div>
    <{if $stu_login == 0}>
    <!--upload-->
    <div class="input-group input-group-sm mb-3 text-end">
        <iframe class="input-group-text" src="upload_stu.html" width="100%" height="130px" id="stu-iframe" scrolling="no"></iframe>
    </div>
    <{/if}>
</div>


<script>
$(document).ready(function(){
    //delete allStu
    $("#stu_delAll").submit(function() {
        event.preventDefault();
        var form = $(this);
        var url = form.attr('action');
        swal({
            title: '確定要刪除？',
            text: '全校學生通通都將會被移除！',
            type: 'warning',
            html: '',
            showCancelButton: true,
            confirmButtonColor: '#DD6B55',
            confirmButtonText: '確定刪除！',
            closeOnConfirm: true ,
            allowOutsideClick: true
            },
            function(){
                $.ajax({
                    url : url,
                    type : 'post',
                    cache: false,
                    data : form.serialize(), // 不用JSON.stringify()
                    dataType : "json", //回傳格式
                    //contentType: "application/json; charset=utf-8",
                    success: function(res){ 
                        if(res.result){
                            $(".stu-btn").attr('class',"stu-btn btn-secondary btn-sm").css("color", "white");
                            showSwal("deleted");
                            setTimeout(function(){ 
                                location.reload();
                            }, 3000);  
                            //swal("成功",data.msg,"success");
                        }else
                            swal("失敗",res.msg,"error");
                    },
                    error: function(xhr){
                        //swal("錯誤","刪除錯誤"+xhr.error,"error");
                        console.log(xhr);
                        showSwal('error');
                    }
                });
        });//end of function and swal
    });//end of delAll

    //upgrade allStu
    $("#upgrade").click(function(){
        let user=$(this).attr('name');
        swal({
            title: '確定要全校升級？',
            text: '除幼兒園外，所有學生都會升年級!!',
            type: 'warning',
            html: '',
            showCancelButton: true,
            confirmButtonColor: '#DD6B55',
            confirmButtonText: '確定升級！',
            allowOutsideClick: true
            },
            function(){
                //$.ajaxSettings.async = false;
                $.get("config.php", {op:"kw_leave_stu_upgrade", user: user })
                .then(function(res){
                    data = JSON.parse(res); //parser JSON物件
                    if(data.result)
                        swal("成功","年級升級成功","success");
                    else
                        swal("失敗",data.msg,"error");
                        //alert('失敗'+res.msg);
                }).fail( function(hxr, error) {
                    console.log(error);
                    swal("錯誤","網路連線錯誤!!","error");
                });
                //$.ajaxSettings.async = true;
        });//end of function and swal
    });//end of update
});//end of ready

function showSwal(type){
    if(type == 'error') //
        swal("錯誤","回傳錯誤!請確認『關閉除錯』!","error");
    else if(type == 'nofile')
        swal("錯誤","請先選擇上傳檔案!","error");
    else if(type== 'deleted')
        swal("成功","全部學生已刪除!","success");
    else if(type=='progress'){
        const imageURL = "./assets/images/spinningwheel_progress.gif";
        swal({
            title: "匯入中...請稍等!",
            //type: "info",
            //html: "<img src='"+imageURL+"' style='width:150px;'>",
            imageUrl: imageURL,
            showConfirmButton: false,
            showCancelButton: false,
            allowOutsideClick: false,
            closeOnConfirm: false ,
            showLoaderOnConfirm: true,
            timer: 3000
        });
    }
    else if(type=="uploaded"){
        swal({
            //position: 'top-end',
            title: '上傳成功',
            type: 'success',
            showConfirmButton: false,
            timer: 1000
        });
    }
}

</script>